//+------------------------------------------------------------------+
//|                                                romanovseo v2.mq4 |
//|                                                    |
//|                                                  seolink@list.ru |
//+------------------------------------------------------------------+
#property copyright " "
#property link      "seolink@list.ru"

extern string s1                    = "Moving Average";
extern int    ma_period1            = 150;
extern int    ma_period2            = 50;
extern int    ma_period3            = 4;
extern int    ma_method             = MODE_SMA;

extern string s2                    = "RSI";
extern bool   rsi_on_of             = true;
extern int    rsi_period            = 14;
extern double rsi_level_up          = 60.0;
extern double rsi_level_dn          = 40.0;

extern string s3                    = "ADX";
extern bool   adx_on_of             = true;
extern int    adx_period            = 14;
extern double adx_level             = 20.0;

extern string s4                    = "MACD";
extern bool   macd_on_of           = true;
extern bool   macd_trend           = true;
extern int    macd1_fast_ema_period = 8;
extern int    macd1_slow_ema_period = 17;

extern int    macd2_fast_ema_period = 12;
extern int    macd2_slow_ema_period = 26;

extern double macd_level_up        = 0.0025;
extern double macd_level_dn        = -0.0025;

extern string s6               ="-==-";
extern int    Magic            = 23012011;
extern double Lot              = 0.0;
extern int    StopLoss         = 500;
extern int    ZeroProfit       = 200;
extern int    Spred            = 3;
extern double Risk             = 2.0;
extern int    Slip             = 30;

extern string s7               = "";
extern bool   Timer            = false;   // true -  , false - 
extern string OnTradePeriod    = "08:00";
extern string EndTradePeriod   = "22:00";

extern string s8            = "  -"; 
extern bool   UseTrail             = false;   //rue -  - , false - 
extern int    TrailStart                = 300;      // -   
extern int    Trail                = 200;      // -  



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if(Total()==0&&TradeTimer()==true)OrderOpen(GetSignal());
   else
   {
   Zero();
   if(UseTrail)TrailingStop();
   CloseOrder();
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
int GetSignal()
{
 if(buy())return(OP_BUY);
 if(sel())return(OP_SELL);
 return(-1);
}
bool buy()
{
 if(MA()!=OP_BUY) return(false);
 if(macd_on_of==true && MACD()!=OP_BUY)return(false);
 if(rsi_on_of==true && RSI()!=OP_BUY)return(false);
 if(adx_on_of==true && ADX()==false)return(false);
 
 return(true);
}
bool sel()
{
 if(MA()!=OP_SELL) return(false);
 if(macd_on_of==true && MACD()!=OP_SELL)return(false);
 if(rsi_on_of==true && RSI()!=OP_SELL)return(false);
 if(adx_on_of==true && ADX()==false)return(false);
 
 return(true);
}
int MA()
{
   double MA1 = iMA(Symbol(),0,ma_period1,0,ma_method,PRICE_CLOSE,0);
   double MA2 = iMA(Symbol(),0,ma_period2,0,ma_method,PRICE_CLOSE,0);
   double MA3 = iMA(Symbol(),0,ma_period3,0,ma_method,PRICE_CLOSE,0);
   
   if(Close[0]>MA1&&MA2>MA1&&MA3>MA2)return(OP_BUY);
   if(Close[0]<MA1&&MA2<MA1&&MA3<MA2)return(OP_SELL);
   
   return(-1);
}
int MACD()
{
 double MACD1 = iMACD(Symbol(),0,macd1_fast_ema_period,macd1_slow_ema_period,9,PRICE_CLOSE,MODE_MAIN,0); 
 double MACD2 = iMACD(Symbol(),0,macd1_fast_ema_period,macd1_slow_ema_period,9,PRICE_CLOSE,MODE_MAIN,1); 
 
 double MACD3 = iMACD(Symbol(),0,macd2_fast_ema_period,macd2_slow_ema_period,9,PRICE_CLOSE,MODE_MAIN,0); 
 double MACD4 = iMACD(Symbol(),0,macd2_fast_ema_period,macd2_slow_ema_period,9,PRICE_CLOSE,MODE_MAIN,1); 
 
 if(macd_trend)
 {
 if(MACD1>macd_level_up&&MACD1>MACD2)return(OP_BUY);
 if(MACD3<macd_level_dn&&MACD3<MACD4)return(OP_SELL);
 }
 else
 {
 if(MACD1>macd_level_up)return(OP_BUY);
 if(MACD3<macd_level_dn)return(OP_SELL);
 }
 
 return(-1);
}
int RSI()
{
 double RSI = iRSI(Symbol(),0,rsi_period,PRICE_CLOSE,0);
 
 if(RSI>rsi_level_up)return(OP_BUY);
 if(RSI<rsi_level_dn)return(OP_SELL);
 
 return(-1);
}
bool ADX()
{
 double ADX = iADX(Symbol(),0,adx_period,PRICE_CLOSE,MODE_MAIN,0); 
 
 if(ADX>adx_level)return(true);
 
 return(false);
}
int Total()
  {
   int cmd;
   int total=OrdersTotal();
   for(int i=0;i<total;i++)
     {
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
           {
            if(OrderType()==OP_BUY || OrderType()==OP_SELL)
              {
               cmd++;
              }
           }
        }
     }
   return(cmd);
  }
  void OrderOpen(int type)
  {
   int t=-1;
   int stoplevel;
   double price;
   double sl;
   double SL;
   double Lots;

   if(type==OP_BUY || type==OP_SELL)
     {
         if(type==OP_BUY)
           {
            RefreshRates();
            stoplevel=MarketInfo(Symbol(),MODE_STOPLEVEL);
            price=NormalizeDouble(Ask,Digits);
            SL = ((price-iMA(Symbol(),0,ma_period1,0,MODE_SMA,PRICE_CLOSE,0))/Point)+StopLoss;
            if(SL>=stoplevel) {sl=NormalizeDouble(Bid -(SL*Point),Digits);Lots = LotPercent(SL);}
            if(SL<stoplevel)  {sl=NormalizeDouble(Bid -(stoplevel*Point),Digits);Lots = LotPercent(stoplevel);}

            if(AccountFreeMarginCheck(Symbol(),OP_BUY,Lots)<0)return;

           }
         if(type==OP_SELL)
           {
            RefreshRates();
            stoplevel=MarketInfo(Symbol(),MODE_STOPLEVEL);
            price=NormalizeDouble(Bid,Digits);
            SL = ((iMA(Symbol(),0,ma_period1,0,MODE_SMA,PRICE_CLOSE,0)-price)/Point)+StopLoss;
            if(SL>=stoplevel) {sl=NormalizeDouble(Ask+(SL*Point),Digits);Lots = LotPercent(SL);}
            if(SL<stoplevel)  {sl=NormalizeDouble(Ask+(stoplevel*Point),Digits);Lots = LotPercent(stoplevel);}

            if(AccountFreeMarginCheck(Symbol(),OP_SELL,Lots)<0)return;
           }
         t=OrderSend(Symbol(),type,Lots,price,Slip,sl,0,NULL,Magic);
         if(t<0)ErrorBlock(GetLastError());

     }
  }
  double LotPercent(double sl)
  {
   double vol=0.0;
   double MinLot = MarketInfo(Symbol(),MODE_MINLOT);
   double MaxLot = MarketInfo(Symbol(),MODE_MAXLOT);

   if(Lot==0.0)vol=(AccountFreeMargin()*Risk)/(sl*MarketInfo(Symbol(),MODE_TICKVALUE)*100.0);
   else vol=Lot;

   if(vol < MinLot)vol = MinLot;
   if(vol > MaxLot)vol = MaxLot;

   return(NormalizeDouble(vol,Okr()));
  }
  int Okr()
  {
   double LotsStep=MarketInfo(Symbol(),MODE_LOTSTEP);
   if(LotsStep==0.01)return(2);
   if(LotsStep==0.1)return(1);
   if(LotsStep==1.0)return(0);
   return(0);
  }
  bool TradeTimer()
  {
   if(Timer==true)
     {
      datetime date=TimeCurrent();
      datetime ty=TimeYear(date);
      datetime tm=TimeMonth(date);
      datetime td1=TimeDay(date);
      datetime td2;

      datetime d1  = StrToTime (ty+"."+tm+"."+td1+" "+OnTradePeriod);
      datetime d2  = StrToTime (ty+"."+tm+"."+td1+" "+EndTradePeriod);

      if(d1>d2 && date>=d1)
        {
         td2=TimeDay(date)+1;
         d1  = StrToTime (ty+"."+tm+"."+td1+" "+OnTradePeriod);
         d2  = StrToTime (ty+"."+tm+"."+td2+" "+EndTradePeriod);
        }
      else if(d1>d2 && date<=d2)
        {
         td2=TimeDay(date)-1;
         d1  = StrToTime (ty+"."+tm+"."+td2+" "+OnTradePeriod);
         d2  = StrToTime (ty+"."+tm+"."+td1+" "+EndTradePeriod);
        }
      if(date>=d1 && date<=d2)return(true);
      else return(false);
     }
   return(true);
  }
  void CloseOrder()
 {
   int digit;
   double price;
   bool res;
   double MA2 = iMA(Symbol(),0,ma_period2,0,ma_method,PRICE_CLOSE,0);
   double MA3 = iMA(Symbol(),0,ma_period3,0,ma_method,PRICE_CLOSE,0);
   
   double MACD1 = iMACD(Symbol(),0,macd1_fast_ema_period,macd1_slow_ema_period,9,PRICE_CLOSE,MODE_MAIN,0); 
   double MACD3 = iMACD(Symbol(),0,macd2_fast_ema_period,macd2_slow_ema_period,9,PRICE_CLOSE,MODE_MAIN,0); 
 
   
   int total=OrdersTotal();
   
   for(int i=total-1; i>=0; i--)
   {
    if(OrderSelect(i,SELECT_BY_POS))
    {
     if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
     {
      if(OrderType()==OP_BUY)
      {
       if(MA3<MA2&&MACD3<macd_level_dn)
       {
        digit=MarketInfo(OrderSymbol(),MODE_DIGITS);
        price=MarketInfo(OrderSymbol(),MODE_BID);
        res=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(price,digit),Slip);
        if(!res)ErrorBlock(GetLastError());
       }
      }
      if(OrderType()==OP_SELL)
      {
       if(MA3>MA2&&MACD3>macd_level_up)
       {
        digit=MarketInfo(OrderSymbol(),MODE_DIGITS);
        price=MarketInfo(OrderSymbol(),MODE_ASK);
        res=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(price,digit),Slip);
        if(!res)ErrorBlock(GetLastError());
       }
      }
      
     }
    }
   }
 }
 void Zero()
 {
  bool res;
  int total=OrdersTotal();
  
  for(int i=total-1; i>=0; i--)
  {
   if(OrderSelect(i,SELECT_BY_POS))
   {
    if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
    {
     if(OrderType()==OP_BUY)
     {
      if(Bid-OrderOpenPrice()>Point*ZeroProfit&&OrderStopLoss()<OrderOpenPrice())
      {
       res = OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid - ((ZeroProfit-Spred)*Point),Digits),OrderTakeProfit(),0);
       if(!res)ErrorBlock(GetLastError());
      }
     }
     if(OrderType()==OP_SELL)
     {
      if(OrderOpenPrice()-Ask>Point*ZeroProfit&&OrderStopLoss()>OrderOpenPrice())
      {
       res = OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask + ((ZeroProfit-Spred)*Point),Digits),OrderTakeProfit(),0);
       if(!res)ErrorBlock(GetLastError());
      }
     }
    }
   }
  }
 }

 void TrailingStop()
 {
  bool res;
  int total=OrdersTotal();
  
  for(int i=total-1; i>=0; i--)
  {
   if(OrderSelect(i,SELECT_BY_POS))
   {
    if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
    {
     if(OrderType()==OP_BUY)
     {
      if(Bid-OrderOpenPrice()>Point*TrailStart)
      {
       if(Bid - OrderStopLoss() > Trail*Point) 
       {
       res = OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid - (Trail*Point),Digits),OrderTakeProfit(),0);
       if(!res)ErrorBlock(GetLastError());
       }
      }
     }
     if(OrderType()==OP_SELL)
     {
      if(OrderOpenPrice()-Ask>Point*TrailStart)
      {
       if(OrderStopLoss() - Ask > Trail*Point) 
       {
       res = OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask + (Trail*Point),Digits),OrderTakeProfit(),0);
       if(!res)ErrorBlock(GetLastError());
       }
      }
     }
    }
   }
  }
 }
  int ErrorBlock(int error)
  {
   switch(error)
     {
      case    0: return(0);
      case    1: {Print(": 1 -        ");return(2);}
      case    2: {Print(": 2 -  .        ");return(3);}
      case    3: {Print(": 3 -       ");return(3);}
      case    4: {Print(": 4 -   ");return(1);}
      case    5: {Print(": 5 -    ");return(3);}
      case    6: {Print(": 6 -     ");return(2);}
      case    7: {Print(": 7 -  ");return(3);}
      case    8: {Print(": 8 -   ");return(2);}
      case    9: {Print(": 9 -     ");return(3);}
      case   64: {Print(": 64 -  .      ");return(3);}
      case   65: {Print(": 65 -   .      ");return(3);}
      case  128: {Print(": 128 -     ");return(1);}
      case  129: {Print(": 129 -   bid  ask, ,  ");return(1);}
      case  130: {Print(": 130 -            (     )");return(1);}
      case  131: {Print(": 131 -  ,    ");return(3);}
      case  132: {Print(": 132 -  ");return(2);}
      case  133: {Print(": 133 -  ");return(3);}
      case  134: {Print(": 134 -     ");return(3);}
      case  135: {Print(": 135 -  ");return(1);}
      case  136: {Print(": 136 -  ");return(1);}
      case  137: {Print(": 137 -  ");return(1);}
      case  138: {Print(": 138 -   ,   bid  ask");return(1);}
      case  139: {Print(": 139 -     ");return(2);}
      case  140: {Print(": 140 -   .   SELL ");return(2);}
      case  141: {Print(": 141 -   ");return(2);}
      case  142: {Print(": 142 -    ");return(2);}
      case  143: {Print(": 143 -     ");return(2);}
      case  144: {Print(": 144 -        ");return(2);}
      case  145: {Print(": 145 -  ,          -   ");return(2);}
      case  146: {Print(": 146 -   .     ,   IsTradeContextBusy  FALSE.");return(1);}
      case  147: {Print(": 147 -      ");return(2);}
      case  148: {Print(": 148 -       ,  ");return(2);}
      case  149: {Print(": 149 -         ,   ");return(2);}
      case 4000: return(0);
      case 4001: {Print(": 4001 -   ");return(3);}
      case 4002: {Print(": 4002 -   -  ");return(3);}
      case 4003: {Print(": 4003 -     ");return(3);}
      case 4004: {Print(": 4004 -     ");return(3);}
      case 4005: {Print(": 4005 -       ");return(3);}
      case 4006: {Print(": 4006 -     ");return(3);}
      case 4007: {Print(": 4007 -     ");return(3);}
      case 4008: {Print(": 4008 -  ");return(3);}
      case 4009: {Print(": 4009 -    ");return(3);}
      case 4010: {Print(": 4010 -     ");return(3);}
      case 4011: {Print(": 4011 -   ");return(3);}
      case 4012: {Print(": 4012 -     ");return(3);}
      case 4013: {Print(": 4013 -   ");return(3);}
      case 4014: {Print(": 4014 -  ");return(3);}
      case 4015: {Print(": 4015 -  ");return(3);}
      case 4016: {Print(": 4016 -  ");return(3);}
      case 4017: {Print(": 4017 -  DLL  ");return(3);}
      case 4018: {Print(": 4018 -   ");return(3);}
      case 4019: {Print(": 4019 -   ");return(3);}
      case 4020: {Print(": 4020 -      ");return(3);}
      case 4021: {Print(": 4021 -    ,   ");return(3);}
      case 4022: {Print(": 4022 -  ");return(3);}
      case 4050: {Print(": 4050 -    ");return(3);}
      case 4051: {Print(": 4051 -    ");return(3);}
      case 4052: {Print(": 4052 -    ");return(3);}
      case 4053: {Print(": 4053 -  ");return(3);}
      case 4054: {Print(": 4054 -   -");return(3);}
      case 4055: {Print(": 4055 -   ");return(3);}
      case 4056: {Print(": 4056 -  ");return(3);}
      case 4057: {Print(": 4057 -    ");return(3);}
      case 4058: {Print(": 4058 -    ");return(3);}
      case 4059: {Print(": 4059 -      ");return(3);}
      case 4060: {Print(": 4060 -   ");return(3);}
      case 4061: {Print(": 4061 -   ");return(3);}
      case 4062: {Print(": 4062 -    string");return(3);}
      case 4063: {Print(": 4063 -    integer");return(3);}
      case 4064: {Print(": 4064 -    double");return(3);}
      case 4065: {Print(": 4065 -     ");return(3);}
      case 4066: {Print(": 4066 -      ");return(3);}
      case 4067: {Print(": 4067 -     ");return(3);}
      case 4099: {Print(": 4099 -  ");return(3);}
      case 4100: {Print(": 4100 -     ");return(3);}
      case 4101: {Print(": 4101 -   ");return(3);}
      case 4102: {Print(": 4102 -    ");return(3);}
      case 4103: {Print(": 4103 -   ");return(3);}
      case 4104: {Print(": 4104 -     ");return(3);}
      case 4105: {Print(": 4105 -     ");return(3);}
      case 4106: {Print(": 4106 -  ");return(3);}
      case 4107: {Print(": 4107 -      ");return(2);}
      case 4108: {Print(": 4108 -   ");return(2);}
      case 4109: {Print(": 4109 -   .         ");return(3);}
      case 4110: {Print(": 4110 -    .    ");return(2);}
      case 4111: {Print(": 4111 -    .    ");return(2);}
      case 4200: {Print(": 4200 -   ");return(3);}
      case 4201: {Print(": 4201 -    ");return(3);}
      case 4202: {Print(": 4202 -   ");return(2);}
      case 4203: {Print(": 4203 -   ");return(3);}
      case 4204: {Print(": 4204 -   ");return(3);}
      case 4205: {Print(": 4205 -   ");return(3);}
      case 4206: {Print(": 4206 -    ");return(3);}
      case 4207: {Print(": 4207 -     ");return(3);}
      default:   {Print(" : ",error);return(3);}
     }
  }